// dynamic_alocation_of_memory_new.cpp
//
#ifdef _WIN32
	#pragma warning(disable:4996)
	#include <tchar.h>
	#include <windows.h>
	#include <conio.h>
	#include <direct.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	#include <stdlib.h>
	#include <sys/types.h>
	#include <sys/stat.h>
	#include <unistd.h>
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <stdio.h>
#include <string.h>
#include <iostream>
using namespace std;

#define MAXLINE 255
//#define MAXLEN 20    Nie je treba!

void my_getch();
void VynasobMatice(const unsigned, const unsigned, const unsigned, long double**, 
	long double**,	long double**);
void VypisMaticu(const unsigned, const unsigned, long double**);
void GetNamesOfIOFiles(const char[], char[]);
//---------------------------------------------------------------------------
int _tmain(int argc, _TCHAR* argv[])
{
	int i, j, m, n, r, s;
	long double** A, ** B, ** C;
	FILE* in;
	char nameoffile[MAXLINE];

	cout << "\n  Program nacita z textoveho suboru dve matice A a B"
		<< " a maticu C = A * B vypise\nna obrazovku.\n\n";

	GetNamesOfIOFiles("MATICE.TXT", nameoffile);
	if ((in = fopen(nameoffile, "r")) == NULL) {
		cout << "  Subor MATICE.TXT sa nepodarilo otvorit.\n\n";
		my_getch();
		return 1;
	}

	fscanf(in, "%i%i", &m, &n);         // mnemotechnicka pomocka
	A = new long double* [m];         // pocet [] a * je 2
	for (i = 0; i < m; i++)
		A[i] = new long double[n];     // pocet [] je 2

	for (i = 0; i < m; i++)
		for (j = 0; j < n; j++)
			fscanf(in, "%Lf", &A[i][j]);

	fscanf(in, "%i%i", &r, &s);
	B = new long double* [r];
	for (i = 0; i < r; i++)
		B[i] = new long double[s];

	if (n != r) {
		cout << "Matice sa nedaju nasobit!";
		my_getch();
		return 0;
	}

	for (i = 0; i < r; i++)
		for (j = 0; j < s; j++)
			fscanf(in, "%Lf", &B[i][j]);
	fclose(in);

	C = new long double* [m];
	for (i = 0; i < m; i++)
		C[i] = new long double[s];

	VynasobMatice(m, n, s, A, B, C);

	cout << "  Z textoveho suboru boli nacitane dve matice:\n  A:\n";
	VypisMaticu(m, n, A);
	cout << "\n  B:\n";
	VypisMaticu(r, s, B);
	cout << "\n  Vysledna matica C=A*B je:\n\n";
	VypisMaticu(m, s, C);

	for (i = 0; i < m; i++)  // Kazde new ma mat svoje delete
		delete[] C[i];
	delete[] C;

	for (i = 0; i < r; i++)
		delete[] B[i];
	delete[] B;

	for (i = 0; i < m; i++)
		delete[] A[i];
	delete[] A;

	my_getch();
	return 0;
}
//---------------------------------------------------------------------------
void my_getch()
{
#ifdef _WIN32
	_getch();
#else
	cout << endl;
#endif
}
//---------------------------------------------------------------------------
// Matice ako parametre funkcie volame odkazom "by dereference"
void VynasobMatice(const unsigned m, const unsigned n, const unsigned s, 
	long double** X, long double** Y, long double** Z)
{
	long double Suma;

	for (unsigned i = 0; i < m; i++)
		for (unsigned j = 0; j < s; j++) {
			Suma = 0;
			for (unsigned k = 0; k < n; k++)
				Suma += X[i][k] * Y[k][j];
			Z[i][j] = Suma;
		}
}
//---------------------------------------------------------------------------
// Maticu ako parameter funkcie volame odkazom "by dereference"
void VypisMaticu(const unsigned m, const unsigned n, long double** X)
{
	for (unsigned i = 0; i < m; i++) {
		for (unsigned j = 0; j < n; j++)
			printf("%12.6Lf", X[i][j]);
		cout << "\n";
	}
}
//---------------------------------------------------------------------------
void GetNamesOfIOFiles(const char name_of_input_file[], char path_to_input_file[])
{
	char current_path[MAXLINE];

#ifdef _WIN32
	TCHAR exePath[MAXLINE];

	HMODULE hModule = GetModuleHandle(NULL);
	if (hModule != NULL) {
		if (!GetModuleFileName(hModule, exePath, MAXLINE)) {
			cout << "Nepodarila sa zistit cesta k exe-suboru.\n";
			my_getch();
			exit(1);
		}
	}
	else {
		cout << "Module handle is NULL.\n" << endl;
		my_getch();
		exit(1);
	}

	int iii;
	bool flag = false;
	for (iii = (int)wcslen(exePath); iii >= 0; iii--) {
		if (!flag && exePath[iii] == '\\') {
			current_path[iii + 1] = '\0';
			flag = true;
		}
		if (flag)
			current_path[iii] = (char)exePath[iii];
	}
#elif (defined __linux__) || (defined __APPLE__)
	unsigned iii;
	char line[MAXLINE];
	FILE* fp;
	if ((fp = popen("/bin/pwd", "r")) == NULL) {
		perror("popen error");
		exit(1);
	}
	if (fgets(line, MAXLINE, fp) == NULL) {
		perror("fgets error");
		exit(1);
	}
	pclose(fp);

	iii = 0;
	while (line[iii] != '\r' && line[iii] != '\n') {
		current_path[iii] = line[iii];
		iii++;
	}
	current_path[iii] = '\0';
#elif (defined _AIX)
	unsigned iii;
	char line[MAXLINE];
	FILE* fp;
	if ((fp = popen("user/bin/pwd", "r")) == NULL) {
		perror("popen error");
		exit(1);
	}
	if (fgets(line, MAXLINE, fp) == NULL) {
		perror("fgets error");
		exit(1);
	}
	pclose(fp);

	iii = 0;
	while (line[iii] != '\r' && line[iii] != '\n') {
		current_path[iii] = line[iii];
		iii++;
	}
	current_path[iii] = '\0';
#endif

	path_to_input_file[0] = '\0';
	strcat(path_to_input_file, current_path);
#if (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	strcat(path_to_input_file, "/inputs/");
#elif (defined _WIN32)
	strcat(path_to_input_file, "inputs\\");
#endif
	strcat(path_to_input_file, name_of_input_file);
}
//---------------------------------------------------------------------------
